_base_ = [
    '../_base_/models/fastfcn_r50-d32_jpu_psp.py',
    '../_base_/datasets/publicdataset_dresden.py',
    '../_base_/default_runtime.py',
    '../_base_/schedules/schedule_300e_val1_check10.py',
]

norm_cfg = dict(
    type='BN',
)

crop_size = (512, 512)

data_preprocessor = dict(
    size=(512, 512),
    mean=[
        103.172638338208,
        61.44762740851152,
        51.407770213021976,
    ],
    std=[
        75.77031253622098,
        54.63616729031377,
        49.45572239497569,
    ],
    bgr_to_rgb=False,
)

model = dict(
    backbone=dict(
        norm_cfg=dict(
            type='BN',
        ),
        depth=50,
    ),
    data_preprocessor=dict(
        size=(512, 512),
        mean=[
            103.172638338208,
            61.44762740851152,
            51.407770213021976,
        ],
        std=[
            75.77031253622098,
            54.63616729031377,
            49.45572239497569,
        ],
        bgr_to_rgb=False,
    ),
    decode_head=dict(
        type='PSPHead',
        in_channels=2048,
        in_index=2,
        channels=512,
        pool_scales=(1, 2, 3, 6),
        dropout_ratio=0.1,
        num_classes=19,
        norm_cfg=dict(
            type='BN',
        ),
        align_corners=False,
        loss_decode=dict(
            type='DiceLoss',
            use_sigmoid=False,
            loss_weight=1.0,
        ),
    ),
    auxiliary_head=dict(
        loss_decode=dict(
            type='DiceLoss',
            use_sigmoid=False,
            loss_weight=0.4,
        ),
        norm_cfg=dict(
            type='BN',
        ),
        num_classes=11,
    ),
)

optim_wrapper = dict(
    type='OptimWrapper',
    _delete_=True,
    optimizer=dict(
        type='AdamW',
        lr=0.0001,
        weight_decay=0.0005,
    ),
    clip_grad=dict(
        max_norm=1,
        norm_type=2,
    ),
)

param_scheduler = [
    dict(
        type='LinearLR',
        start_factor=1e-06,
        by_epoch=True,
        begin=0,
        end=10,
    ),
    dict(
        type='PolyLR',
        power=0.9,
        begin=10,
        end=300,
        eta_min=1e-05,
        by_epoch=True,
    ),
]

